biblioteca_charo/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
	path('accounts/', include('django.contrib.auth.urls')),
    path('admin/', admin.site.urls),
    path('', include('prestamos_profesores.urls')),
]

prestamos_profesores/urls.py
from django.urls import include, path
from rest_framework import routers
from .views import (
	PaginaInicioView,
	MateriaViewSet,
	TurnoViewSet,
	HorarioViewSet,
	CursoViewSet,
	MaterialViewSet,
	PrestamoViewSet,
	IndexView,
	PrestamosFalseView,
	PrestamoDetalle,
	CrearPrestamo,
	ModificarPrestamo,
	EliminarPrestamo
)


router = routers.DefaultRouter()
router.register('materias', MateriaViewSet)
router.register('turnos', TurnoViewSet)
router.register('horarios', HorarioViewSet)
router.register('cursos', CursoViewSet)
router.register('materiales', MaterialViewSet)
router.register('prestamos', PrestamoViewSet)


app_name = 'prestamos_profesores'
urlpatterns = [
	path('api/', include(router.urls)),
	path('', PaginaInicioView.as_view(), name='pagina_inicio'),
	path('prestamos/', IndexView.as_view(), name='prestamos'),
	path('prestamos-sin-devolver/', PrestamosFalseView.as_view(), name='prestamos_sin_devolver'),
	path('detalle-prestamo/<int:pk>', PrestamoDetalle.as_view(), name='detalle'),
	path('crear-prestamo/', CrearPrestamo.as_view(), name='crear'),
	path('modificar-prestamo/<int:pk>', ModificarPrestamo.as_view(), name='modificar'),
	path('eleminar-prestamo/<int:pk>', EliminarPrestamo.as_view(), name='eliminar'),
]

prestamos_profesores/models.py
# -*- coding: utf-8 -*-
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator
#from django.core.exceptions import ValidationError

class Materia(models.Model):
	nombre = models.CharField(
		'Nombre de materia',
		max_length=60,
		help_text='Ingrese el nombre de la materia.',
		unique=True
	)

	def __str__(self):
		return '%s' % (self.nombre)

	class Meta:
		verbose_name_plural = 'Materias'


class Turno(models.Model):
	tipo = models.CharField(
		'Turno en el que solicita',
		max_length=50,
		help_text='Ingrese si el profesor es de taller o teoría',
		unique=True
	)

	def __str__(self):
		return '%s' % (self.tipo)

	class Meta:
		verbose_name_plural = 'Turnos'


class Horario(models.Model):
	desde = models.TimeField(
		'Comienzo de bloque',
		help_text='Ingrese el horario que comienza el bloque',
		null=True,
		blank=True
	)
	hasta = models.TimeField(
		'Término del bloque',
		help_text='Ingrese el horario en el que finaliza el bloque',
		null=True,
		blank=True
	)

	def __str__(self):
		return '%shs %shs' % (self.desde, self.hasta)

	class Meta:
		verbose_name_plural = 'Horarios'
		unique_together = ['desde', 'hasta']



class Curso(models.Model):
	año = models.PositiveSmallIntegerField(
		'Año del curso:',
		help_text='Ingrese el año del curso',
		validators=[
			MaxValueValidator(6),
			MinValueValidator(1)
		]
	)
	division = models.PositiveSmallIntegerField(
		'Division del curso',
		help_text='Ingrese la división del curso',
		validators=[
			MaxValueValidator(7),
			MinValueValidator(1)
		]
	)

	def __str__(self):
		return '%s° %s°' % (self.año, self.division)

	class Meta:
		verbose_name_plural = 'Cursos'
		unique_together = ['año', 'division']

class Material(models.Model):
	nombre = models.CharField(
		'Nombre del material',
		max_length=50,
		help_text='Ingrese el nombre del material',
		unique=True
	)

	def __str__(self):
		return '%s' % (self.nombre)

	class Meta:
		verbose_name_plural = "Materiales"


class Prestamo(models.Model):
	fecha = models.DateField(
		'Fecha',
		help_text='Ingrese la fecha de reserva dd/mm/aa',
#		validators=['validate_date']
	)
	turno = models.ForeignKey(
		Turno,
		on_delete = models.CASCADE,
		help_text = 'Seleccione el turno'
	)
	material = models.ForeignKey(
		Material,
		on_delete=models.CASCADE,
		help_text='Seleccione el material que se va a prestar'
	)
	curso = models.ForeignKey(
		Curso,
		on_delete=models.CASCADE,
		help_text='Seleccione el curso al que va el profesor'
	)
	profesor = models.CharField(
		'Nombre y apellido del profesor:',
		max_length=70,
		help_text='Ingrese el nombre y el apellido del profesor'
	)
	materia = models.ForeignKey(
		Materia,
		on_delete=models.CASCADE,
		help_text='Seleccione la materia que da el profesor'
	)
	horario = models.ForeignKey(
		Horario,
		on_delete=models.CASCADE,
		help_text='Seleccione el horario de préstamo'
	)
	devolucion = models.BooleanField(default=False)

	def __str__(self):
		return '%s %s %s' % (self.fecha, self.profesor, self.material)

#	def validate_date(fecha):
#		if fecha < timezone.now().date():
#			raise ValidationError("La fecha no puede ser anterior a la actual.")

	class Meta:
		verbose_name_plural = 'Prestamos'
		unique_together = ['fecha', 'turno', 'material', 'horario']
		ordering = ['fecha']

prestamos_profesores/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import ListView, TemplateView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from rest_framework import viewsets
from django.urls import reverse_lazy
from .serializers import (
	MateriaSerializer,
	TurnoSerializer,
	HorarioSerializer,
	CursoSerializer,
	MaterialSerializer,
	PrestamoSerializer
)
from .models import (
	Materia,
	Turno,
	Horario,
	Curso,
	Material,
	Prestamo
)

class MateriaViewSet(viewsets.ModelViewSet):
	queryset = Materia.objects.all()
	serializer_class = MateriaSerializer

class TurnoViewSet(viewsets.ModelViewSet):
	queryset = Turno.objects.all()
	serializer_class = TurnoSerializer

class HorarioViewSet(viewsets.ModelViewSet):
	queryset = Horario.objects.all()
	serializer_class = HorarioSerializer

class CursoViewSet(viewsets.ModelViewSet):
	queryset = Curso.objects.all()
	serializer_class = CursoSerializer

class MaterialViewSet(viewsets.ModelViewSet):
	queryset = Material.objects.all()
	serializer_class = MaterialSerializer

class PrestamoViewSet(viewsets.ModelViewSet):
	queryset = Prestamo.objects.all()
	serializer_class = PrestamoSerializer


class PaginaInicioView(TemplateView):
	template_name = 'pagina_inicio.html'

class IndexView(LoginRequiredMixin, ListView):
	model = Prestamo
	template_name = "prestamos_profesores.html"
	context_object_name = 'prestamos'


class PrestamosFalseView(LoginRequiredMixin, ListView):
	model = Prestamo
	template_name = "prestamos_profesores.html"
	queryset = Prestamo.objects.filter(devolucion=False)
	context_object_name = 'prestamos'


class PrestamoDetalle(LoginRequiredMixin, DetailView):
	model = Prestamo
	template_name = 'detalle_prestamo.html'
	context_object_name = 'prestamo'


class CrearPrestamo(LoginRequiredMixin, CreateView):
	model = Prestamo
	fields = ['fecha', 'turno', 'material', 'curso', 'profesor', 'materia', 'horario', 'devolucion']
	template_name = 'crear_prestamo.html'
	success_url = reverse_lazy('prestamos_profesores:prestamos')

#def form_valid(self):
#	fecha = self.cleaned_fecha['fecha']
#	if fecha < timezone.now().date():
#		raise forms.ValidationError("La fecha no puede ser anterior a la actual.")
#	self.object.save()
#	return fecha



class ModificarPrestamo(LoginRequiredMixin, UpdateView):
	model = Prestamo
	fields = ['fecha', 'turno', 'material', 'curso', 'profesor', 'materia', 'horario', 'devolucion']
	template_name = 'modificar_prestamo.html'
	success_url = reverse_lazy('prestamos_profesores:prestamos')


class EliminarPrestamo(LoginRequiredMixin, DeleteView):
	model = Prestamo
	template_name = 'eliminar_prestamo.html'
	success_url = reverse_lazy('prestamos_profesores:prestamos')
	

templates/base.html
<!DOCTYPE html>
<html lang="es">
<head>
	<meta charset="UTF-8">
	
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
	
	<title>{% block titulo %}{% endblock titulo %}</title>

</head>
<body>
	{% block menu %}
		<nav class="navbar navbar-expand-lg navbar-light bg-light">
		  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo01" aria-controls="navbarTogglerDemo01" aria-expanded="false" aria-label="Toggle navigation">
		    <span class="navbar-toggler-icon"></span>
		  </button>
		  <div class="collapse navbar-collapse" id="navbarTogglerDemo01">
		    <ul class="navbar-nav mr-auto mt-2 mt-lg-0">
		    	<li class="navbar-brand" href="#">Biblioteca</li>
		    	{% if user.is_authenticated %}
		      		<li>
		        	<a class="nav-link" href="{% url 'prestamos_profesores:prestamos' %}">Prestamos Generales</a>
		     		</li>
		     		<li>
		     			<a class="nav-link" href="{% url 'prestamos_profesores:prestamos_sin_devolver' %}">Prestamos Sin Devolver</a>
		     		</li>
		    </ul>
		     		<a class="nav-link btn btn-outline-danger" href="{% url 'logout' %}">Cerrar Sesión</a>
				{% else %}
						<a class="nav-link btn btn-outline-success" href="{% url 'login' %}">Ingresar</a>
				{% endif %}
		  </div>
		</nav>
	{% endblock menu %}

	{% block contenido %}{% endblock contenido %}
	<!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
</body>
</html>

templates/crear_prestamo.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block titulo %}Crear Pregunta{% endblock titulo %}
{% block contenido %}
	<div class="container">
		<div class="col mt-3 p-3 mb-2 bg-light text-dark border border-success rounded">
			<form action="" method="post">
				{% csrf_token %} <!--Este código siempre tenemos que ponerlo cuando creamos un formulario por post, es un método de seguridad que pide si o si django-->
				{{ form|crispy }}
				<br>
				<input type="submit" class="btn btn-secondary text-white" value="Crear prestamo">
			</form>
		</div>	
	</div>
	
{% endblock contenido %}

templates/detalle_prestamo.html
{% extends "base.html" %}
{% block titulo %}
	Detalle del Prestamo
{% endblock titulo %}
{% block contenido %}
	<div class="container">
		<div class="row">
			<div class="col">
				<table class="table">
					<thead>
						<tr>
							<th>Fecha</th>
							<th>Material</th>
							<th>Profesor</th>
							<th>Turno</th>
							<th>Curso</th>
							<th>Materia</th>
							<th>Horario</th>
							<th>Devolución</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<th>{{ prestamo.fecha }}</th>
							<td>{{ prestamo.material }}</td>
							<td>{{ prestamo.profesor }}</td>
							<td>{{ prestamo.turno }}</td>
							<td>{{ prestamo.curso }}</td>
							<td>{{ prestamo.materia }}</td>
							<td>{{ prestamo.horario }}</td>
							<td>{{ prestamo.devolucion|yesno:'Sí,No' }}</td>
						</tr>
					</tbody>
				</table>
			</div>
		</div>
	</div>
{% endblock contenido %}

templates/eliminar_prestamo.html
{% extends "base.html" %}
{% block titulo %}
	Eliminar Préstamo
{% endblock titulo %}
{% block contenido %}
	<div class="container">
		<div class="row">
			<div class="p-4 col-md-8 mt-3 border border-danger rounded">
				<form action="" method="post">
					{% csrf_token %}
					<p>Eliminar: <strong>{{ object }}</strong></p>
					<input type="submit" class="btn btn-danger text-white" value="Confirmar">
				</form>
			</div>
		</div>
	</div>
{% endblock contenido %}

templates/modificar_prestamo.html
{% extends "base.html" %}
{% load crispy_forms_tags %}
{% block titulo %}
	Modificar Préstamo
{% endblock titulo %}
{% block contenido %}
	<div class="container">
		<div class="col mt-3 p-3 mb-2 bg-light text-dark border border-success rounded" >
			<form action="" method="post">
				{% csrf_token %}
				{{ form|crispy }}
				<input type="submit" class="btn btn-secondary text-white" value="Modificar">
			</form>
		</div>
	</div>
{% endblock contenido %}

templates/pagina_inicio.html
{% extends "base.html" %}

{% block titulo %}
	Inicio
{% endblock titulo %}

{% block contenido %}
	<div class="container">
		<div class="ml-5 mt-5">
			<h1 class="h1">¡Bienvenido/a al sistema de la biblioteca!</h1>
			<div class='mt-5 mr-4'>
				<p class="lead">
					Este sistema te permitirá dar de alta y gestionar los préstamos que se le otorgan a los profesores del establecimiento.
				</p>
				<p class="lead">
					Para poder usar el sistema y las opciones que el mismo te brinda, deberás estar logueado ya que trabajamos con requisitos de autentificación para que no cualquiera pueda utilizarlo.
				</p>
				<p class="lead">
					Si ya tienes una cuenta de administrador, por favor haz clic en el botón de la esquina superior izquierda que dice "Ingresar" e ingresa tus datos para poder utilizar el sistema.
				</p>
				<p class="lead">
					Si no te aparece dicho botón pero si te aparecen las opciones para navegar dentro del sistema, es porque ya estás logueado. Simplemente, elige una de las opciones para empezar a trabajar.
				</p>
			</div>
		</div>
	</div>
{% endblock contenido %}

templates/prestamos_profesores.html
{% extends 'base.html' %}

{% block titulo %}Préstamos Profesores{% endblock titulo %}

{% block contenido %}
	<div class="container">
		<h1>Lista de Préstamos</h1>
		
			<a class="btn btn-secondary m-2" tabindex="-1" role="button" aria-disabled="true" href="{% url 'prestamos_profesores:crear' %}">Agregar Préstamo</a>
		
		
	</div>
	<div class="container">
		<div class="row">
			<div class="col">
				<table class="table">
					<thead>
						<tr>
							<th>Fecha</th>
							<th>Material</th>
							<th>Profesor</th>
							<th>Turno</th>
							<th>Curso</th>
							<th>Devolución</th>
							<th>Editar</th>
							<th>Eliminar</th>
						</tr>
					</thead>
					<tbody>
						{% for prestamo in prestamos %}
							<tr>
								<th><p><a class="text-success" href="{% url 'prestamos_profesores:detalle' prestamo.id %}">{{ prestamo.fecha|date:"d - m - Y" }}</a></p></th>
								<td>{{ prestamo.material }}</td>
								<td>{{ prestamo.profesor }}</td>
								<td>{{ prestamo.turno }}</td>
								<td>{{ prestamo.curso }}</td>
								<td>{{ prestamo.devolucion|yesno:'Sí,No' }}</td>
								<td><p><a class="text-success" href="{% url 'prestamos_profesores:modificar' prestamo.id %}">Editar</a></p></td>
								<td><p><a class="text-danger" href="{% url 'prestamos_profesores:eliminar' prestamo.id %}">Eliminar</a></p></td>
							</tr>
						{% endfor %}
					</tbody>
				</table>
			</div>
		</div>
	</div>
{% endblock contenido %}